<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="上户日期" prop="inDate">
        <el-date-picker
          v-model="queryParams.inDate"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="下户日期" prop="outDate">
        <el-date-picker
          v-model="queryParams.outDate"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="订单ID" prop="id">
        <el-input
          v-model="queryParams.id"
          placeholder="请输入订单ID"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
<!--      <el-form-item label="订单城市" prop="city">-->
<!--        <el-input-->
<!--          v-model="queryParams.city"-->
<!--          placeholder="请输入订单城市"-->
<!--          clearable-->
<!--          @keyup.enter="handleQuery"-->
<!--          class="!w-240px"-->
<!--        />-->
<!--      </el-form-item>-->
<!--      <el-form-item label="合同id" prop="contractId">-->
<!--        <el-input-->
<!--          v-model="queryParams.contractId"-->
<!--          placeholder="请输入合同id"-->
<!--          clearable-->
<!--          @keyup.enter="handleQuery"-->
<!--          class="!w-240px"-->
<!--        />-->
<!--      </el-form-item>-->
<!--      <el-form-item label="需求id" prop="requestId">-->
<!--        <el-input-->
<!--          v-model="queryParams.requestId"-->
<!--          placeholder="请输入需求id"-->
<!--          clearable-->
<!--          @keyup.enter="handleQuery"-->
<!--          class="!w-240px"-->
<!--        />-->
<!--      </el-form-item>-->
      <el-form-item label="月嫂id" prop="yuesaoId">
        <el-input
          v-model="queryParams.yuesaoId"
          placeholder="请输入月嫂id"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="用户id" prop="userId">
        <el-input
          v-model="queryParams.userId"
          placeholder="请输入用户id"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="订单状态" prop="status">
        <el-select
          v-model="queryParams.status"
          placeholder="请选择订单状态"
          clearable
          class="!w-240px"
        >
          <el-option label="待签约" :value="0" />
          <el-option label="待审核" :value="5" />
          <el-option label="待上户" :value="1" />
          <el-option label="已上户" :value="2" />
          <el-option label="已完成" :value="3" />
          <el-option label="已取消" :value="4" />
        </el-select>
      </el-form-item>
<!--      <el-form-item label="定金状态 0是未支付 1是支付成功 2是支付失败 3是定金已退款" prop="dingjinStatus">-->
<!--        <el-select-->
<!--          v-model="queryParams.dingjinStatus"-->
<!--          placeholder="请选择定金状态 0是未支付 1是支付成功 2是支付失败 3是定金已退款"-->
<!--          clearable-->
<!--          class="!w-240px"-->
<!--        >-->
<!--          <el-option label="请选择字典生成" value="" />-->
<!--        </el-select>-->
<!--      </el-form-item>-->
<!--      <el-form-item label="定金数额" prop="dingjinMount">-->
<!--        <el-input-->
<!--          v-model="queryParams.dingjinMount"-->
<!--          placeholder="请输入定金数额"-->
<!--          clearable-->
<!--          @keyup.enter="handleQuery"-->
<!--          class="!w-240px"-->
<!--        />-->
<!--      </el-form-item>-->
<!--      <el-form-item label="订单评价" prop="comment">-->
<!--        <el-input-->
<!--          v-model="queryParams.comment"-->
<!--          placeholder="请输入订单评价"-->
<!--          clearable-->
<!--          @keyup.enter="handleQuery"-->
<!--          class="!w-240px"-->
<!--        />-->
<!--      </el-form-item>-->
<!--      <el-form-item label="补充条款" prop="supplement">-->
<!--        <el-input-->
<!--          v-model="queryParams.supplement"-->
<!--          placeholder="请输入补充条款"-->
<!--          clearable-->
<!--          @keyup.enter="handleQuery"-->
<!--          class="!w-240px"-->
<!--        />-->
<!--      </el-form-item>-->
      <el-form-item label="签单时间" prop="signTime">
        <el-date-picker
          v-model="queryParams.signTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker
          v-model="queryParams.createTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-240px"
        />
      </el-form-item>
<!--      <el-form-item label="false是不使用平台交付订单，true表示使用平台交付订单" prop="dingjinIsPlatform">-->
<!--        <el-input-->
<!--          v-model="queryParams.dingjinIsPlatform"-->
<!--          placeholder="请输入false是不使用平台交付订单，true表示使用平台交付订单"-->
<!--          clearable-->
<!--          @keyup.enter="handleQuery"-->
<!--          class="!w-240px"-->
<!--        />-->
<!--      </el-form-item>-->
      <el-form-item label="退款时间" prop="refundTime">
        <el-date-picker
          v-model="queryParams.refundTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery">搜索</el-button>
        <el-button @click="resetQuery">重置</el-button>
        <el-button type="primary" @click="openForm('create')" v-hasPermi="['yuesao:order:create']">
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['yuesao:order:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="false">
      <el-table-column label="订单ID" align="center" prop="id" min-width="180px" fixed="left" />
      <el-table-column label="订单上户日期" width="200" align="center" prop="inDate" />
      <el-table-column label="订单下户日期" width="200" align="center" prop="outDate" />
      <el-table-column label="订单价格" align="center" prop="price" />
      <el-table-column label="订单城市" align="center" prop="city" />
      <el-table-column label="合同id" align="center" prop="contractId" />
      <el-table-column label="需求id" align="center" prop="requestId" />
      <el-table-column label="月嫂id" align="center" prop="yuesaoId" />
      <el-table-column label="用户id" align="center" prop="userId" />

      <el-table-column label="订单状态" align="center" prop="status">
        <template #default="{row}">
          <el-tag>{{ orderConf[row.status] }}</el-tag>
        </template>
      </el-table-column>

      <el-table-column label="定金状态" align="center" prop="dingjinStatus">
        <template #default="{row}">
          <el-tag>{{ depositConf[row.dingjinStatus] }}</el-tag>
        </template>
      </el-table-column>
      
      <el-table-column label="定金数额" align="center" prop="dingjinMount" />
      <el-table-column label="订单评价" align="center" prop="comment" />
      <el-table-column label="补充条款" align="center" prop="supplement" />
      <el-table-column
        label="签单时间"
        align="center"
        prop="signTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
        <el-table-column label="是否使用平台交付订单" align="center" prop="dingjinIsPlatform" >
            <template #default="{row}">
                {{row.dingjinIsPlatform ? '是' : '否'}}
            </template>
        </el-table-column>
      <el-table-column
        label="退款时间"
        align="center"
        prop="refundTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column
        label="操作"
        align="center"
        fixed="right"
        min-width="120px"
      >
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="onContract(scope.row)"
          >
            查看合同
          </el-button>
          <el-button
            v-if="scope.row.status === 5"
            link
            type="primary"
            @click="auditPass(scope.row)"
          >
            通过
          </el-button>
          <el-button
            v-if="scope.row.status === 5"
            link
            type="primary"
            @click="auditReject(scope.row)"
          >
            拒绝
          </el-button>
<!--          <el-button-->
<!--            link-->
<!--            type="primary"-->
<!--            @click="openForm('update', scope.row.id)"-->
<!--            v-hasPermi="['yuesao:order:update']"-->
<!--          >-->
<!--            编辑-->
<!--          </el-button>-->
<!--          <el-button-->
<!--            link-->
<!--            type="danger"-->
<!--            @click="handleDelete(scope.row.id)"-->
<!--            v-hasPermi="['yuesao:order:delete']"-->
<!--          >-->
<!--            删除-->
<!--          </el-button>-->
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <OrderForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import * as OrderApi from '@/api/order'
import OrderForm from './OrderForm.vue'
import { depositConf, orderConf } from './const';
import { Message } from '@/layout/components/Message';

defineOptions({ name: 'Order' })

const route = useRoute()
const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const total = ref(0) // 列表的总页数
const list = ref([]) // 列表的数据
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
	id: null,
  inDate: [],
  outDate: [],
  price: null,
  city: null,
  contractId: null,
  requestId: null,
  yuesaoId: null,
  userId: null,
  status: null,
  dingjinStatus: null,
  dingjinMount: null,
  comment: null,
  supplement: null,
  signTime: [],
  createTime: [],
  dingjinIsPlatform: null,
  refundTime: []
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await OrderApi.getOrderPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await OrderApi.deleteOrder(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await OrderApi.exportOrder(queryParams)
    download.excel(data, '订单表	.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

const onContract = async (row) => {
	try {
    const { static_url } = await OrderApi.getContract({ id: row.id })

    if (static_url) {
      window.open(static_url, '_blank')
    } else {
      message.error('暂无合同')
    }
  } catch {
    message.error('获取合同失败')
  }
} 

const auditPass = async (row) => {
	console.log(row);
	try {
    await OrderApi.audit({ orderId: row.id, state: 1 })
    message.alert('审核完成')
    await getList()
  } catch {

  }
}

const auditReject = async (row) => {
  const data = await message.prompt('请输入审核不通过的原因', '')
  try {
   await OrderApi.audit({ orderId: row.id, state: 4, comment: data.value })
    message.alert('审核完成')
    await getList()
  } catch {

  }
}

/** 初始化 **/
onMounted(() => {
  if (route.query.userId) {
    queryParams.userId = Number(route.query.userId) 
  }
  if (route.query.id) {
    queryParams.id = Number(route.query.id) 
  }
  getList()
})
</script>
